#!/bin/sh

HOSTNAME=`hostname`
. /var/run/dsltool.conf

DIR=/tmp
cd $DIR
FILES="dsltool.txt dsltool.pcap dsltool.dat dsltool-*.png"

# extract dsltool.txt from rc.cfg 
grep DSLTOOL /etc/rc.cfg > dsltool.txt

# start tcpdump
tcpdump -XX -s 0 -i any -w dsltool.pcap host $DSLTOOL_HOST and port 23 &
tcpdumppid=$!
sleep 1

# run  dsltool
dsltool -m$DSLTOOL_HOST -u$DSLTOOL_USER -p$DSLTOOL_PASS -f$DIR/ info

# stop tcpdump
sleep 1
kill $tcpdumppid
sleep 1

# pack files 
tar -czf dsltool.tgz $FILES
